import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PayableOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../../../../../common";
export type MultiCallStruct = {
    target: PromiseOrValue<string>;
    callData: PromiseOrValue<BytesLike>;
};
export type MultiCallStructOutput = [string, string] & {
    target: string;
    callData: string;
};
export interface ICreditFacadeInterface extends utils.Interface {
    functions: {
        "addCollateral(address,address,uint256)": FunctionFragment;
        "approve(address,address,uint256)": FunctionFragment;
        "approveAccountTransfer(address,bool)": FunctionFragment;
        "calcCreditAccountHealthFactor(address)": FunctionFragment;
        "calcTotalValue(address)": FunctionFragment;
        "closeCreditAccount(address,uint256,bool,(address,bytes)[])": FunctionFragment;
        "creditManager()": FunctionFragment;
        "decreaseDebt(uint256)": FunctionFragment;
        "degenNFT()": FunctionFragment;
        "enableToken(address)": FunctionFragment;
        "hasOpenedCreditAccount(address)": FunctionFragment;
        "increaseDebt(uint256)": FunctionFragment;
        "isTokenAllowed(address)": FunctionFragment;
        "limits()": FunctionFragment;
        "liquidateCreditAccount(address,address,uint256,bool,(address,bytes)[])": FunctionFragment;
        "liquidateExpiredCreditAccount(address,address,uint256,bool,(address,bytes)[])": FunctionFragment;
        "multicall((address,bytes)[])": FunctionFragment;
        "openCreditAccount(uint256,address,uint16,uint16)": FunctionFragment;
        "openCreditAccountMulticall(uint256,address,(address,bytes)[],uint16)": FunctionFragment;
        "params()": FunctionFragment;
        "transferAccountOwnership(address)": FunctionFragment;
        "transfersAllowed(address,address)": FunctionFragment;
        "underlying()": FunctionFragment;
        "version()": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "addCollateral" | "approve" | "approveAccountTransfer" | "calcCreditAccountHealthFactor" | "calcTotalValue" | "closeCreditAccount" | "creditManager" | "decreaseDebt" | "degenNFT" | "enableToken" | "hasOpenedCreditAccount" | "increaseDebt" | "isTokenAllowed" | "limits" | "liquidateCreditAccount" | "liquidateExpiredCreditAccount" | "multicall" | "openCreditAccount" | "openCreditAccountMulticall" | "params" | "transferAccountOwnership" | "transfersAllowed" | "underlying" | "version"): FunctionFragment;
    encodeFunctionData(functionFragment: "addCollateral", values: [
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "approve", values: [
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "approveAccountTransfer", values: [PromiseOrValue<string>, PromiseOrValue<boolean>]): string;
    encodeFunctionData(functionFragment: "calcCreditAccountHealthFactor", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "calcTotalValue", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "closeCreditAccount", values: [
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<boolean>,
        MultiCallStruct[]
    ]): string;
    encodeFunctionData(functionFragment: "creditManager", values?: undefined): string;
    encodeFunctionData(functionFragment: "decreaseDebt", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "degenNFT", values?: undefined): string;
    encodeFunctionData(functionFragment: "enableToken", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "hasOpenedCreditAccount", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "increaseDebt", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "isTokenAllowed", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "limits", values?: undefined): string;
    encodeFunctionData(functionFragment: "liquidateCreditAccount", values: [
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<boolean>,
        MultiCallStruct[]
    ]): string;
    encodeFunctionData(functionFragment: "liquidateExpiredCreditAccount", values: [
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<boolean>,
        MultiCallStruct[]
    ]): string;
    encodeFunctionData(functionFragment: "multicall", values: [MultiCallStruct[]]): string;
    encodeFunctionData(functionFragment: "openCreditAccount", values: [
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "openCreditAccountMulticall", values: [
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<string>,
        MultiCallStruct[],
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "params", values?: undefined): string;
    encodeFunctionData(functionFragment: "transferAccountOwnership", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "transfersAllowed", values: [PromiseOrValue<string>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "underlying", values?: undefined): string;
    encodeFunctionData(functionFragment: "version", values?: undefined): string;
    decodeFunctionResult(functionFragment: "addCollateral", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "approve", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "approveAccountTransfer", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "calcCreditAccountHealthFactor", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "calcTotalValue", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "closeCreditAccount", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "creditManager", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "decreaseDebt", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "degenNFT", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "enableToken", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "hasOpenedCreditAccount", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "increaseDebt", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isTokenAllowed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "limits", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "liquidateCreditAccount", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "liquidateExpiredCreditAccount", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "multicall", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "openCreditAccount", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "openCreditAccountMulticall", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "params", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "transferAccountOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "transfersAllowed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "underlying", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "version", data: BytesLike): Result;
    events: {};
}
export interface ICreditFacade extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: ICreditFacadeInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        addCollateral(onBehalfOf: PromiseOrValue<string>, token: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        approve(targetContract: PromiseOrValue<string>, token: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        approveAccountTransfer(from: PromiseOrValue<string>, state: PromiseOrValue<boolean>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        calcCreditAccountHealthFactor(creditAccount: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber] & {
            hf: BigNumber;
        }>;
        calcTotalValue(creditAccount: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber, BigNumber] & {
            total: BigNumber;
            twv: BigNumber;
        }>;
        closeCreditAccount(to: PromiseOrValue<string>, skipTokenMask: PromiseOrValue<BigNumberish>, convertWETH: PromiseOrValue<boolean>, calls: MultiCallStruct[], overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        creditManager(overrides?: CallOverrides): Promise<[string]>;
        decreaseDebt(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        degenNFT(overrides?: CallOverrides): Promise<[string]>;
        enableToken(token: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        hasOpenedCreditAccount(borrower: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        increaseDebt(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        isTokenAllowed(token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        limits(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            minBorrowedAmount: BigNumber;
            maxBorrowedAmount: BigNumber;
        }>;
        liquidateCreditAccount(borrower: PromiseOrValue<string>, to: PromiseOrValue<string>, skipTokenMask: PromiseOrValue<BigNumberish>, convertWETH: PromiseOrValue<boolean>, calls: MultiCallStruct[], overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        liquidateExpiredCreditAccount(borrower: PromiseOrValue<string>, to: PromiseOrValue<string>, skipTokenMask: PromiseOrValue<BigNumberish>, convertWETH: PromiseOrValue<boolean>, calls: MultiCallStruct[], overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        multicall(calls: MultiCallStruct[], overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        openCreditAccount(amount: PromiseOrValue<BigNumberish>, onBehalfOf: PromiseOrValue<string>, leverageFactor: PromiseOrValue<BigNumberish>, referralCode: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        openCreditAccountMulticall(borrowedAmount: PromiseOrValue<BigNumberish>, onBehalfOf: PromiseOrValue<string>, calls: MultiCallStruct[], referralCode: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        params(overrides?: CallOverrides): Promise<[
            BigNumber,
            boolean,
            number
        ] & {
            maxBorrowedAmountPerBlock: BigNumber;
            isIncreaseDebtForbidden: boolean;
            expirationDate: number;
        }>;
        transferAccountOwnership(to: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        transfersAllowed(from: PromiseOrValue<string>, to: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        underlying(overrides?: CallOverrides): Promise<[string]>;
        version(overrides?: CallOverrides): Promise<[BigNumber]>;
    };
    addCollateral(onBehalfOf: PromiseOrValue<string>, token: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    approve(targetContract: PromiseOrValue<string>, token: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    approveAccountTransfer(from: PromiseOrValue<string>, state: PromiseOrValue<boolean>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    calcCreditAccountHealthFactor(creditAccount: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
    calcTotalValue(creditAccount: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber, BigNumber] & {
        total: BigNumber;
        twv: BigNumber;
    }>;
    closeCreditAccount(to: PromiseOrValue<string>, skipTokenMask: PromiseOrValue<BigNumberish>, convertWETH: PromiseOrValue<boolean>, calls: MultiCallStruct[], overrides?: PayableOverrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    creditManager(overrides?: CallOverrides): Promise<string>;
    decreaseDebt(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    degenNFT(overrides?: CallOverrides): Promise<string>;
    enableToken(token: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    hasOpenedCreditAccount(borrower: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    increaseDebt(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    isTokenAllowed(token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    limits(overrides?: CallOverrides): Promise<[
        BigNumber,
        BigNumber
    ] & {
        minBorrowedAmount: BigNumber;
        maxBorrowedAmount: BigNumber;
    }>;
    liquidateCreditAccount(borrower: PromiseOrValue<string>, to: PromiseOrValue<string>, skipTokenMask: PromiseOrValue<BigNumberish>, convertWETH: PromiseOrValue<boolean>, calls: MultiCallStruct[], overrides?: PayableOverrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    liquidateExpiredCreditAccount(borrower: PromiseOrValue<string>, to: PromiseOrValue<string>, skipTokenMask: PromiseOrValue<BigNumberish>, convertWETH: PromiseOrValue<boolean>, calls: MultiCallStruct[], overrides?: PayableOverrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    multicall(calls: MultiCallStruct[], overrides?: PayableOverrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    openCreditAccount(amount: PromiseOrValue<BigNumberish>, onBehalfOf: PromiseOrValue<string>, leverageFactor: PromiseOrValue<BigNumberish>, referralCode: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    openCreditAccountMulticall(borrowedAmount: PromiseOrValue<BigNumberish>, onBehalfOf: PromiseOrValue<string>, calls: MultiCallStruct[], referralCode: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    params(overrides?: CallOverrides): Promise<[
        BigNumber,
        boolean,
        number
    ] & {
        maxBorrowedAmountPerBlock: BigNumber;
        isIncreaseDebtForbidden: boolean;
        expirationDate: number;
    }>;
    transferAccountOwnership(to: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    transfersAllowed(from: PromiseOrValue<string>, to: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    underlying(overrides?: CallOverrides): Promise<string>;
    version(overrides?: CallOverrides): Promise<BigNumber>;
    callStatic: {
        addCollateral(onBehalfOf: PromiseOrValue<string>, token: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        approve(targetContract: PromiseOrValue<string>, token: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        approveAccountTransfer(from: PromiseOrValue<string>, state: PromiseOrValue<boolean>, overrides?: CallOverrides): Promise<void>;
        calcCreditAccountHealthFactor(creditAccount: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        calcTotalValue(creditAccount: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber, BigNumber] & {
            total: BigNumber;
            twv: BigNumber;
        }>;
        closeCreditAccount(to: PromiseOrValue<string>, skipTokenMask: PromiseOrValue<BigNumberish>, convertWETH: PromiseOrValue<boolean>, calls: MultiCallStruct[], overrides?: CallOverrides): Promise<void>;
        creditManager(overrides?: CallOverrides): Promise<string>;
        decreaseDebt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        degenNFT(overrides?: CallOverrides): Promise<string>;
        enableToken(token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        hasOpenedCreditAccount(borrower: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        increaseDebt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        isTokenAllowed(token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        limits(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            minBorrowedAmount: BigNumber;
            maxBorrowedAmount: BigNumber;
        }>;
        liquidateCreditAccount(borrower: PromiseOrValue<string>, to: PromiseOrValue<string>, skipTokenMask: PromiseOrValue<BigNumberish>, convertWETH: PromiseOrValue<boolean>, calls: MultiCallStruct[], overrides?: CallOverrides): Promise<void>;
        liquidateExpiredCreditAccount(borrower: PromiseOrValue<string>, to: PromiseOrValue<string>, skipTokenMask: PromiseOrValue<BigNumberish>, convertWETH: PromiseOrValue<boolean>, calls: MultiCallStruct[], overrides?: CallOverrides): Promise<void>;
        multicall(calls: MultiCallStruct[], overrides?: CallOverrides): Promise<void>;
        openCreditAccount(amount: PromiseOrValue<BigNumberish>, onBehalfOf: PromiseOrValue<string>, leverageFactor: PromiseOrValue<BigNumberish>, referralCode: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        openCreditAccountMulticall(borrowedAmount: PromiseOrValue<BigNumberish>, onBehalfOf: PromiseOrValue<string>, calls: MultiCallStruct[], referralCode: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        params(overrides?: CallOverrides): Promise<[
            BigNumber,
            boolean,
            number
        ] & {
            maxBorrowedAmountPerBlock: BigNumber;
            isIncreaseDebtForbidden: boolean;
            expirationDate: number;
        }>;
        transferAccountOwnership(to: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        transfersAllowed(from: PromiseOrValue<string>, to: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        underlying(overrides?: CallOverrides): Promise<string>;
        version(overrides?: CallOverrides): Promise<BigNumber>;
    };
    filters: {};
    estimateGas: {
        addCollateral(onBehalfOf: PromiseOrValue<string>, token: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        approve(targetContract: PromiseOrValue<string>, token: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        approveAccountTransfer(from: PromiseOrValue<string>, state: PromiseOrValue<boolean>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        calcCreditAccountHealthFactor(creditAccount: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        calcTotalValue(creditAccount: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        closeCreditAccount(to: PromiseOrValue<string>, skipTokenMask: PromiseOrValue<BigNumberish>, convertWETH: PromiseOrValue<boolean>, calls: MultiCallStruct[], overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        creditManager(overrides?: CallOverrides): Promise<BigNumber>;
        decreaseDebt(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        degenNFT(overrides?: CallOverrides): Promise<BigNumber>;
        enableToken(token: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        hasOpenedCreditAccount(borrower: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        increaseDebt(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        isTokenAllowed(token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        limits(overrides?: CallOverrides): Promise<BigNumber>;
        liquidateCreditAccount(borrower: PromiseOrValue<string>, to: PromiseOrValue<string>, skipTokenMask: PromiseOrValue<BigNumberish>, convertWETH: PromiseOrValue<boolean>, calls: MultiCallStruct[], overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        liquidateExpiredCreditAccount(borrower: PromiseOrValue<string>, to: PromiseOrValue<string>, skipTokenMask: PromiseOrValue<BigNumberish>, convertWETH: PromiseOrValue<boolean>, calls: MultiCallStruct[], overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        multicall(calls: MultiCallStruct[], overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        openCreditAccount(amount: PromiseOrValue<BigNumberish>, onBehalfOf: PromiseOrValue<string>, leverageFactor: PromiseOrValue<BigNumberish>, referralCode: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        openCreditAccountMulticall(borrowedAmount: PromiseOrValue<BigNumberish>, onBehalfOf: PromiseOrValue<string>, calls: MultiCallStruct[], referralCode: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        params(overrides?: CallOverrides): Promise<BigNumber>;
        transferAccountOwnership(to: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        transfersAllowed(from: PromiseOrValue<string>, to: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        underlying(overrides?: CallOverrides): Promise<BigNumber>;
        version(overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        addCollateral(onBehalfOf: PromiseOrValue<string>, token: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        approve(targetContract: PromiseOrValue<string>, token: PromiseOrValue<string>, amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        approveAccountTransfer(from: PromiseOrValue<string>, state: PromiseOrValue<boolean>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        calcCreditAccountHealthFactor(creditAccount: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        calcTotalValue(creditAccount: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        closeCreditAccount(to: PromiseOrValue<string>, skipTokenMask: PromiseOrValue<BigNumberish>, convertWETH: PromiseOrValue<boolean>, calls: MultiCallStruct[], overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        creditManager(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        decreaseDebt(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        degenNFT(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        enableToken(token: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        hasOpenedCreditAccount(borrower: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        increaseDebt(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        isTokenAllowed(token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        limits(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        liquidateCreditAccount(borrower: PromiseOrValue<string>, to: PromiseOrValue<string>, skipTokenMask: PromiseOrValue<BigNumberish>, convertWETH: PromiseOrValue<boolean>, calls: MultiCallStruct[], overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        liquidateExpiredCreditAccount(borrower: PromiseOrValue<string>, to: PromiseOrValue<string>, skipTokenMask: PromiseOrValue<BigNumberish>, convertWETH: PromiseOrValue<boolean>, calls: MultiCallStruct[], overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        multicall(calls: MultiCallStruct[], overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        openCreditAccount(amount: PromiseOrValue<BigNumberish>, onBehalfOf: PromiseOrValue<string>, leverageFactor: PromiseOrValue<BigNumberish>, referralCode: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        openCreditAccountMulticall(borrowedAmount: PromiseOrValue<BigNumberish>, onBehalfOf: PromiseOrValue<string>, calls: MultiCallStruct[], referralCode: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        params(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        transferAccountOwnership(to: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        transfersAllowed(from: PromiseOrValue<string>, to: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        underlying(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        version(overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
